cc.Class({
    extends: cc.Component,

    properties: {
        skeletonList:   [sp.Skeleton],

        nodeList:       [cc.Node],
    },

    onSpineClick: function () {
        let idx = 0;

        let func = function () {
            let skeleton = this.skeletonList[idx];
            if (skeleton) {
                if (idx == 0 || idx == 2) {
                    skeleton.setAnimation(0, 'Jump', false);
                } else {
                    skeleton.setAnimation(0, 'jump', false);
                }
                skeleton.setCompleteListener(function (trackEntry, event) {
                    console.log('---atk1 done--', idx, Date.parse(new Date()));
                    skeleton.setAnimation(0, 'walk', true);
                    skeleton.setCompleteListener(function (trackEntry, event) {});
                    idx++;
                    func();
                }.bind(this));
            }            
        }.bind(this);
        
        func();        
    },

    onActionClick: function () {
        let idx = 0;

        let func = function () {
            let node = this.nodeList[idx];
            if (node) {
                let action = cc.sequence(
                    cc.moveTo(0.5, cc.p(100, node.y)),
                    cc.scaleTo(0.1, 1.0),
                    cc.moveTo(0.5, cc.p(260, node.y)),
                    cc.callFunc(function () {
                        console.log('----runAction-', idx, Date.parse(new Date()));
                        idx++;
                        func();
                    }),
                    cc.scaleTo(0.5, 1.2),
                );
                node.runAction(action);
            }
        }.bind(this);

        func();
    },
});
